# FACT Data Project
Software to execute workflows to extract, process, unify, store, and retrieve data from FACT data services.

---

[![GitLab License](https://img.shields.io/gitlab/license/fact%2Futils%2FFACT_data_project.jl?gitlab_url=https%3A%2F%2Fgit.nilu.no&style=flat&color=orange)](https://www.gnu.org/licenses/agpl-3.0.en.html#license-text)
[![DOI](https://img.shields.io/badge/DOI-10.17605%2FOSF.IO%2FVDCJ3-blue?style=flat)](https://doi.org/10.17605/OSF.IO/VDCJ3)

---

## Use
1. To install the package in your project from our [Local Registry](https://git.nilu.no/julia/registry):
```julia
using Pkg
Pkg.Registry.add(url="https://git.nilu.no/julia/registry")
Pkg.add("FACT_data_project")
```
2. To use the package:
```julia
using FACT_data_project
``````
Please refer to the package documentation for details on how to this package: https://fact.pages.nilu.no/utils/FACT_data_project.jl/

System deployment and data workflows are defined in .TOML files. Refer to the [template](./projects/template.toml) for the required structure and syntax.

### To compute the data

To start a specific project file

> julia --project=@. src/FACT_compute_dataset.jl nm_counties.toml


### Download data
To download the data of a specific project file

> julia --project=@. src/FACT_download_dataset.jl nm_counties.toml nm_counties.csv

Dataset can be exported to the formats: '.json', '.csv', '.dta', '.parquet', and '.sqlite'. Data joins (and join types) are defined in the project file.

Files are saved in the [./data](./data/) directory following intuitive naming conventions derived from the file name and project configuration requested.

---
## Specifications


---
## Notes

---
## Author
Riccardo Boero - ribo@nilu.no

## License
[![AGPL v3](https://www.gnu.org/graphics/agplv3-88x31.png "License Icon")](https://www.gnu.org/licenses/agpl-3.0.en.html#license-text)

## Citation

- Boero, Riccardo. 2024. “FACT Utils: FACT Data Project.” OSF. [doi:10.17605/OSF.IO/FQEA7](https://doi.org/10.17605/OSF.IO/FQEA7). 

Part of the Fine scAle eConomic daTa - FACT project:
- Boero, Riccardo. 2024. “Fine scAle eConomic daTa - FACT.” OSF. [doi:10.17605/OSF.IO/PV4ZW](https://doi.org/10.17605/OSF.IO/PV4ZW). 

